package com.activeTuts.fsm
{
	
	import flash.display.Sprite;

	public class Car extends Sprite 
	{				
		public static const ONE_SIXTH_SECONDS:Number = 1 / 6; //6 times per second
		
		private const IDLE_FUEL_CONSUMPTION:Number = .0055;
		private const DRIVE_FUEL_CONSUMPTION:Number = .011;
		
		///CAR STATES
		private static const ENGINE_OFF:String = 'off';
		private static const ENGINE_ON:String = 'on';
		private static const ENGINE_DRIVE_FORWARD:String = 'driving forward';
		private static const ENGINE_OUT_OF_FUEL:String = 'out of fuel';
		
		private var _currentState:String = ENGINE_OFF;
		
		private var _engineTimer:Number = 0;
		private var _fullCapacity:Number = 1;
		private var _fuelSupply:Number = _fullCapacity; //in gallons
		
		public function Car () {}
		
		public function update ($tick:Number):void 
		{
			
			switch (_currentState)
			{
				case ENGINE_OFF: 
				//
				break;
				
				case ENGINE_ON:
				_engineTimer += $tick;
				
				//gas consumption and trace statement
				if (_engineTimer >= ONE_SIXTH_SECONDS) //6 times per second interval
				{				
					trace ('vm');
					_engineTimer -= ONE_SIXTH_SECONDS;
					
					consumeFuel (IDLE_FUEL_CONSUMPTION);///30 seconds gas supply
				}
				break;
				
				case ENGINE_DRIVE_FORWARD: 
				_engineTimer += $tick;
				
				if (_engineTimer >= ONE_SIXTH_SECONDS)
				{
					trace ('vroomm');
					_engineTimer -= ONE_SIXTH_SECONDS;
					
					consumeFuel (DRIVE_FUEL_CONSUMPTION);///15 seconds gas supply
				}
				break;
				
				case ENGINE_OUT_OF_FUEL:
				//
				break;
			}
		}
		
		///car functions
		public function turnKeyOn ():void
		{
			trace ("attempting to turn the car on...");
			
			switch (_currentState)
			{
				case ENGINE_OFF: 
				trace ("Turning the car on...the engine is now running!");
				_currentState = ENGINE_ON;
				break;
				
				case ENGINE_ON: 
				trace ("the engine's already running you didn't have to crank the ignition!");
				break;
				
				case ENGINE_DRIVE_FORWARD:
				trace ("you're driving so don't crank the ignition!");
				break;
				
				case ENGINE_OUT_OF_FUEL:
				trace ("no fuel - the car will not start, get some fuel before anything. Returning the key to the off position.");
				break;
			}
		}
		
		public function turnKeyOff ():void
		{
			trace ("attempting to turn the car off...");
			
			switch (_currentState)
			{
				case ENGINE_OFF:
				trace ("The car's already off, you can't turn the key counter-clockwise any further...");
				break;
				
				case ENGINE_ON:
				trace ("click... the engine has been turned off from park.");
				
				_currentState = ENGINE_OFF;
				break;
				
				case ENGINE_DRIVE_FORWARD:
				trace ("nvrm...click... rolling to a stop...the engine has been turned off.");
				_currentState = ENGINE_OFF;
				break;
				
				case ENGINE_OUT_OF_FUEL:
				trace ("you already did this when the fuel ran out earlier...");
				break;
			}
		}
		
		public function driveForward ():void
		{
			trace ("attempting to drive forward...");
			switch (_currentState)
			{
				case ENGINE_OFF:
				trace ("click, changing the gear to drive doesn't do anything...the car is not running, returning the gear to park...");
				break;
				
				case ENGINE_ON:
				trace ("click, changing gears to drive ...now were going somewhere...");
				_currentState = ENGINE_DRIVE_FORWARD;
				break;
				
				case ENGINE_DRIVE_FORWARD:
				trace ("already driving - no need to change anything...");
				break;
				
				case ENGINE_OUT_OF_FUEL: 
				trace ("click, changing the gear to drive won't do anything...the car has no fuel, returning the gear to park...");
				break;
			}
		}
		
		private function consumeFuel ($consumption:Number):void
		{
			
			if ((_fuelSupply -= $consumption) <= 0)
			{
				_fuelSupply = 0;
				trace ("phit...phit - the engine has stopped, no more fuel to run, returning the gear to park...");
				_currentState = ENGINE_OUT_OF_FUEL;
			}
		}
		
		public function reFuel ():void
		{
			trace ("attempting to refuel...");
			
			if (_fuelSupply == 1) 
			{
				trace ("no need to refuel right now, the tank is full.");
				return;
			}
			
			switch (_currentState)
			{
				case ENGINE_OFF:
				trace ("getting out of the car and...");
				break;
				
				case ENGINE_ON:
				trace ("turning the key to off position, getting out of the car and...");
				_currentState = ENGINE_OFF;
				break;
				
				case ENGINE_DRIVE_FORWARD:
				trace ("nchanging gear from drive to park and turning the key to off position, getting out of the car and...");
				_currentState = ENGINE_OFF;
				break;
				
				case ENGINE_OUT_OF_FUEL:
				trace ("turning the key to the off position, getting out of the car and...");
				_currentState = ENGINE_OFF;
				break;
			}
			
			var neededSupply:Number = _fullCapacity - _fuelSupply;
			
			_fuelSupply += neededSupply;
			trace ("filling up to " + _fuelSupply + " gallon(s) of fuel.");
		}
		
		override public function toString ():String 
		{
			return "The car is currently " + _currentState + " with a fuel amount of " + _fuelSupply.toFixed (2) +  " gallon(s).";
		}
		
	}
	
}
