package com.activeTuts.fsm
{	
	public class EngineDriveForward implements IState
	{
		private var _car:Car;
		
		public function EngineDriveForward($car:Car) 
		{
			_car = $car;
		}
		
		/* INTERFACE com.activeTuts.fsm.IState */
		
		public function turnKeyOff ():void
		{
			_car.print ("click... rolling to a stop...the engine has been turned off.");
			_car.changeState (_car.getEngineOffState ());
		}
		
		public function turnKeyOn ():void
		{
			_car.print ("you're driving so don't crank the ignition!");
		}
		
		public function driveForward ():void
		{
			_car.print ("already driving - no need to change anything...");
		}
		
		
		public function reFuel ():void
		{
			if (_car.hasFullTank () == false) 
			{
				_car.print ("stopping the car, changing gears to park, turning the key to the off position, getting out of the car and adding " 
				+ Number (_car.refillWithFuel ()).toFixed (2) + " gallon(s) of fuel.");
				_car.changeState (_car.getEngineOffState ());
			}
		}
		
		public function update ($tick:Number):void
		{
			_car.engineTimer += $tick;
			
			if (_car.engineTimer >= Car.ONE_SIXTH_SECONDS)
			{
				_car.engineTimer -= Car.ONE_SIXTH_SECONDS;
				
				_car.consumeFuel (Car.DRIVE_FUEL_CONSUMPTION);///15 seconds gas supply
			}
		}
		
		public function toString ():String 
		{
			return 'driving forward';
		}
		
	}

}