package com.activeTuts.fsm 
{
	public class EngineOff implements IState
	{
		private var _car:Car;
		
		public function EngineOff($car:Car) 
		{
			_car = $car;
		}
		
		/* INTERFACE com.activeTuts.fsm.IState */
		
		public function turnKeyOff ():void
		{
			_car.print ("The car's already off, you can't turn the key counter-clockwise any further...");
		}
		
		public function turnKeyOn ():void
		{
			_car.print ("Turning the car on...the engine is now running!");
			_car.changeState (_car.getEngineOnState ());
		}
		
		public function driveForward ():void
		{
			_car.print ("click, changing the gear to drive doesn't do anything...the car is not running, returning the gear to park...");
		}
		
		public function reFuel ():void
		{
			if (_car.hasFullTank () == false) 
			{
				_car.print ("getting out of the car and adding " + Number (_car.refillWithFuel ()).toFixed (2) + " gallon(s) of fuel.");
			}			
		}
		
		public function update ($tick:Number):void { }
		
		public function toString ():String 
		{
			return 'off';
		}
		
	}

}