package com.activeTuts.fsm
{	
	public class EngineOn implements IState
	{
		private var _car:Car;
		
		public function EngineOn($car:Car) 
		{
			_car = $car;
		}
		
		/* INTERFACE com.activeTuts.fsm.IState */
		
		public function turnKeyOff ():void
		{
			_car.print ("click... the engine has been turned off from park.");
		}
		
		public function turnKeyOn ():void
		{
			_car.print ("the engine's already running you didn't have to crank the ignition!");
		}
		
		public function driveForward ():void
		{
			_car.print ("click, changing gears to drive ...now were going somewhere...");
			_car.changeState (_car.getEngineDriveForwardState ());
		}
		
		public function reFuel ():void
		{
			if (_car.hasFullTank () == false) 
			{
				_car.print ("turning the car off, getting out and adding " + Number (_car.refillWithFuel ()).toFixed (2) + " gallon(s) of fuel.");
				_car.changeState (_car.getEngineOffState ());
			}
		}
		
		public function update ($tick:Number):void
		{			
			_car.engineTimer += $tick;
			
			if (_car.engineTimer >= Car.ONE_SIXTH_SECONDS) //6 times per second interval
			{					
				_car.engineTimer -= Car.ONE_SIXTH_SECONDS; //start from 0 + the overlap for accuracy
				
				_car.consumeFuel (Car.IDLE_FUEL_CONSUMPTION);///30 seconds gas supply
			}
		}
		
		public function toString ():String 
		{
			return 'on';
		}
		
	}

}