package com.activeTuts.fsm
{	
	public class EngineOutOfFuel implements IState
	{
		private var _car:Car;
		
		public function EngineOutOfFuel($car:Car) 
		{
			_car = $car;
		}
		
		/* INTERFACE com.activeTuts.fsm.IState */
		
		public function turnKeyOff ():void
		{
			_car.print ("you already did this when the fuel ran out earlier...");
		}
		
		public function turnKeyOn ():void
		{
			_car.print ("no fuel - the car will not start, get some fuel before anything. Returning the key to the off position.");
		}
		
		public function driveForward ():void
		{
			_car.print ("click, changing the gear to drive doesn't do anything...the car has no fuel, returning the gear to park...");
		}
		
		public function reFuel ():void
		{
			if (_car.hasFullTank () == false) 
			{
				_car.print ("getting out of the car and adding " + _car.refillWithFuel () + " gallon(s) of fuel.");
				_car.changeState (_car.getEngineOffState ());
			}
		}
		
		public function update ($tick:Number):void { }
		
		public function toString ():String 
		{
			return 'out of fuel';
		}
		
	}

}