package  com.activeTuts.fsm
{
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.utils.getTimer;
	
	[SWF (width = 500, height = 350, frameRate = 60, backgroundColor = 0xFFFFFF)]
	
	public class Main extends Sprite 
	{		
		private var _past:Number;
		private var _present:Number;
		
		private var _tick:Number;
		
		private var _car:Car;
		
		private var _initiatedTest1:Boolean;
		private var _initiatedTest2:Boolean;
		private var _initiatedTest3:Boolean;
		private var _initiatedTest4:Boolean;
		private var _initiatedTest5:Boolean;
		private var _initiatedTest6:Boolean;
		
		private var _finalActions:Boolean;
		
		private var _counter:Number = 0;
		
		public function Main () 
		{			
			_present = getTimer ();
			
			trace ('Start of constructor = ' + _present * 0.001 + ' seconds\n');
			_past = _present;
			
			_car = new Car;
			addChild (_car);
			
			addEventListener (Event.ENTER_FRAME, update);
			
			///test 0
			_car.turnKeyOff ();
			trace (_car);
			_car.driveForward ();
			trace (_car);
			_car.turnKeyOn ();
			trace (_car);
		}
		
		private function update (e:Event):void 
		{
			_present = getTimer ();
			_tick = (_present - _past) * .001; ///converted to 1/1000
			_past = _present;
			
			_counter += _tick; ///used for tests with timed execution.
			
			_car.update (_tick);
			
			//test 1 after 5 seconds of running the car
			if (_counter >= 5 && ! _initiatedTest1)
			{
				_initiatedTest1 = true;
				
				_car.reFuel ();
				_car.reFuel ();
				_car.driveForward ();				
				_car.turnKeyOff ();
				_car.turnKeyOff ();
				_car.driveForward ();
				_car.turnKeyOn ();
				_car.driveForward ();
				trace (_car);
			}
			
			//test 2 after 11 seconds
			if (_counter >= 11 && ! _initiatedTest2)
			{
				_initiatedTest2 = true;
				
				_car.turnKeyOff ();
				_car.turnKeyOn ();
				_car.driveForward ();
				trace (_car);
			}
			
			//test 3 after 30 seconds
			if (_counter >= 30 && ! _initiatedTest3)
			{
				_initiatedTest3 = true;
				
				_car.turnKeyOn ();
				_car.turnKeyOff ();
				_car.turnKeyOn ();
				_car.driveForward ();
				_car.turnKeyOn ();
				_car.turnKeyOff ();
				_car.turnKeyOn ();
				trace (_car);
			}
			
			//test 4 after 35 seconds 
			if (_counter >= 35 && ! _initiatedTest4)
			{
				_initiatedTest4 = true;
				
				_car.reFuel ();
				_car.reFuel ();
				trace (_car);
				
				_car.turnKeyOff ();
				_car.driveForward ();
				_car.turnKeyOff ();
				_car.turnKeyOff ();
				_car.turnKeyOn ();
				trace (_car);
			}
			
			//test 5 after 42 seconds 
			if (_counter >= 42 && ! _initiatedTest5)
			{
				_initiatedTest5 = true;
				
				_car.driveForward ();
				trace (_car);
			}
			
			//test 6 after 45 seconds 
			if (_counter >= 45 && ! _initiatedTest6)
			{
				_initiatedTest6 = true;
				
				_car.turnKeyOn ();
				_car.turnKeyOn ();
				_car.driveForward ();
				trace (_car);
			}
			
			///stop the car after 60 seconds
			if (_counter >= 60 && ! _finalActions)
			{
				_finalActions = true;
				
				trace ('elapsed ' + getTimer () / 1000);
				
				_car.turnKeyOff ();
				trace (_car);
			}
		}
			
			
			///TEST RESULT
			/**
			Start of constructor = 1.805 seconds
			
			attempting to turn the car off...
			The car's already off, you can't turn the key counter-clockwise any further...
			The car is currently off with a fuel amount of 1.00 gallon(s).
			attempting to drive forward...
			click, changing the gear to drive doesn't do anything...the car is not running, returning the gear to park...
			The car is currently off with a fuel amount of 1.00 gallon(s).
			attempting to turn the car on...
			Turning the car on...the engine is now running!
			The car is currently on with a fuel amount of 1.00 gallon(s).
			vm
			--
			vm
			attempting to refuel...
			turning the key to off position, getting out of the car and...
			filling up to 1 gallon(s) of fuel.
			attempting to refuel...
			no need to refuel right now, the tank is full.
			attempting to drive forward...
			click, changing the gear to drive doesn't do anything...the car is not running, returning the gear to park...
			attempting to turn the car off...
			The car's already off, you can't turn the key counter-clockwise any further...
			attempting to turn the car off...
			The car's already off, you can't turn the key counter-clockwise any further...
			attempting to drive forward...
			click, changing the gear to drive doesn't do anything...the car is not running, returning the gear to park...
			attempting to turn the car on...
			Turning the car on...the engine is now running!
			attempting to drive forward...
			click, changing gears to drive ...now were going somewhere...
			The car is currently driving forward with a fuel amount of 1.00 gallon(s).
			vroomm
			--
			vroomm
			attempting to turn the car off...
			nvrm...click... rolling to a stop...the engine has been turned off.
			attempting to turn the car on...
			Turning the car on...the engine is now running!
			attempting to drive forward...
			click, changing gears to drive ...now were going somewhere...
			The car is currently driving forward with a fuel amount of 0.60 gallon(s).
			vroomm
			--
			vroomm
			phit...phit - the engine has stopped, no more fuel to run, returning the gear to park...
			attempting to turn the car on...
			no fuel - the car will not start, get some fuel before anything. Returning the key to the off position.
			attempting to turn the car off...
			you already did this when the fuel ran out earlier...
			attempting to turn the car on...
			no fuel - the car will not start, get some fuel before anything. Returning the key to the off position.
			attempting to drive forward...
			click, changing the gear to drive won't do anything...the car has no fuel, returning the gear to park...
			attempting to turn the car on...
			no fuel - the car will not start, get some fuel before anything. Returning the key to the off position.
			attempting to turn the car off...
			you already did this when the fuel ran out earlier...
			attempting to turn the car on...
			no fuel - the car will not start, get some fuel before anything. Returning the key to the off position.
			The car is currently out of fuel with a fuel amount of 0.00 gallon(s).
			attempting to refuel...
			turning the key to the off position, getting out of the car and...
			filling up to 1 gallon(s) of fuel.
			attempting to refuel...
			no need to refuel right now, the tank is full.
			The car is currently off with a fuel amount of 1.00 gallon(s).
			attempting to turn the car off...
			The car's already off, you can't turn the key counter-clockwise any further...
			attempting to drive forward...
			click, changing the gear to drive doesn't do anything...the car is not running, returning the gear to park...
			attempting to turn the car off...
			The car's already off, you can't turn the key counter-clockwise any further...
			attempting to turn the car off...
			The car's already off, you can't turn the key counter-clockwise any further...
			attempting to turn the car on...
			Turning the car on...the engine is now running!
			The car is currently on with a fuel amount of 1.00 gallon(s).
			vm
			--
			vm
			attempting to drive forward...
			click, changing gears to drive ...now were going somewhere...
			The car is currently driving forward with a fuel amount of 0.77 gallon(s).
			vroomm
			--
			vroomm
			attempting to turn the car on...
			you're driving so don't crank the ignition!
			attempting to turn the car on...
			you're driving so don't crank the ignition!
			attempting to drive forward...
			already driving - no need to change anything...
			The car is currently driving forward with a fuel amount of 0.57 gallon(s).
			vroomm
			--
			vroomm
			phit...phit - the engine has stopped, no more fuel to run, returning the gear to park...
			elapsed 61.812
			attempting to turn the car off...
			you already did this when the fuel ran out earlier...
			The car is currently out of fuel with a fuel amount of 0.00 gallon(s).
			*/
			
		
	}
	
}
